# tutorial_api

Pasos para instalación: 

1.- Crear Virtualenv
2.- instalar con pip y python 3.6 lo siguiente: 
	
	.- flask
	.- flask-restplus
	.- sqlalchemy
	.- .




 





	Miscelaneous Notes:

	.- CORS (Cross Origin Resource Sharing) para habilitar CORS, sencillo se le pasa la app

Route specific CORS via decorator
This extension also exposes a simple decorator to decorate flask routes with. Simply add @cross_origin() below a call to Flask’s @app.route(..) to allow CORS on a given route. See the full list of options in the decorator documentation.

Tambien es posible asignar la caracteristica de CORS a una sola ruta de la aplicación con el decorator @cross_origin() de la siguiente manera:

@app.route("/")
@cross_origin()
def miFuncion():
  return "Hola, mundo cross-origin!"


Que es un decorator?
R: Son objetos que se pueden llamar para modificar una función o una clase, de manera que  


In Python, everything is object. Functions in Python are first-class objects which means that they can be referenced by a variable, added in the lists, passed as arguments to another function etc.

En Python todo es un objeto, las funciones en Python son objetos de primera clase, lo que significa que pueden ser referenciados por una variable, insertados en listas, pasados como argumentos a otra función, entre otras cosas.




Introducción 

Las comunicaciones entre aplicaciones que trabajan conectadas a internet son cada día mas importantes, es por eso que han surgido formas de comunicarse entre programas de manera que se pueda compartir datos e información entre los mismos de forma sencilla y rápida, una de las tecnologías mas usadas para este tipo de comunicación son las APIs (Application Program Interface) o interface de programación de aplicaciones, cuyo objetivo es brindar las vías y los mecanismos necesarios para que otras aplicaciones puedan conectarse y establecer una comunicación.

Las API RESTful o también llamadas Servicios Web RESTful, están basadas en la tecnología REST (Representational state transfer) o Estado de transferencia representacional y consisten en un enfoque moderno para las comunicaciones a través de servicios web, esta tecnología es generalmente es mas utilizada para las comunicaciones que el protocolo robusto SOAP (SINGLE OBJECT ACCESS PROTOCOL) ya que consume menos ancho de banda, haciéndolo mucho mas adecuado para las comunicaciones en internet, ademas de que toma ventaja del protocolo HTTP con el cual tenemos los métodos GET (para obtener un recurso), PUT (para alterar o modificar un recurso), POST (para crear un recurso) y DELETE (para eliminar un recurso).


Cliente - Servidor

Primero que nada, aclaremos que el cliente no es el usuario, sino la aplicación que utiliza el usuario para poder conectarse con el servidor, de manera que es cliente es un programa que suele enviar peticiones al servidor, este a su vez le responde con la información pertinente.

Usualmente el concepto de cliente-servidor indica que el cliente el y el servidor deberían estar separados de manera que se permitan evolucionar de forma independiente. De esta manera los desarrolladores pueden hacer cambios en una aplicación en el teléfono sin necesidad de impactar la estructura de la data que se maneja o el diseño de la base de datos en el servidor. De igual manera debería poder realizar cambios en el servidor sin necesidad de hacer cambios en el cliente.  


Sin Estado (stateless)

Cuando se habla de stateless en el ambito de las APIs RESTful, quiere decir que estas no conservan estado, las llamadas pueden hacerse de manera independiente una con respecto a las otras, y cada llamada deberá contener los datos suficientes para que la misma sea completada exitosamente, para esto se añaden en algunos casos datos como API key, access token, User ID, etc. un API RESTful requiere que cualquier estado sea guardado en el cliente y no en el servidor.


URI y URL

Las URI o Uniform Resource Identifier consiste en un texto que sirve para identificar las URL o Uniform Resource Locations, no debemos confundir estos terminos ya que las URL en lugar de identificar lo que hacen es que localizan el recurso que se está tratando de obtener.

un ejemplo de una URL sería: 

http://miweb.com/hoteles

y un ejemplo de URI puede ser

/hoteles

En las API RESTful se utilizan las URI para definir una serie de claves o reglas a través de las cuales se podrán comunicar entre distintas aplicaciones, por ejemplo si una aplicación requiere ver la lista de hoteles, envía su petición a la dirección URL que contiene el URI /hotels, este URI debe poderse configurar para que dependiendo del método HTTP que el cliente utilice, se puedan hacer una actividad u otra actividad.

REFERENCIAS

https://searchmicroservices.techtarget.com/definition/RESTful-API

https://www.mulesoft.com/resources/api/what-is-rest-api-design

https://www.programiz.com/python-programming/namespace

https://stackoverflow.com/questions/9807382/what-is-a-web-service-endpoint