from sqlalchemy import Integer, String
from sqlalchemy.sql.schema import ForeignKey

import enum
from app.extensions import db


class City(db.Model):
    __tablename__ = 'city'
    id = db.Column(Integer, primary_key=True)
    name = db.Column(String(100), nullable=False)

    def __init__(self, name):
        self.name = name

    def __repr__(self):
        return '<City %r>' % (self.name)

    @staticmethod
    def from_json(json):
        c = City(
            name=json.get('name')
        )
        return c

    def to_json(self):
        return {
            'id': self.id,
            'name': self.name
        }
