from sqlalchemy import Integer, String, Boolean, Enum, TIME
from sqlalchemy.sql.schema import ForeignKey

import enum
from app.extensions import db



class Hotel(db.Model):
    __tablename__ = 'hotel'
    id = db.Column(Integer, primary_key=True)
    #code = db.Column(String(100), unique=True)
    name = db.Column(String(100), nullable=False)
    #city_id = db.Column(Integer, ForeignKey('city.id'), nullable=False)
    city = db.Column(String, nullable=False)
    address = db.Column(String, nullable=False)

    def __init__(self, name, city, address):
        self.name = name
        self.city = city
        self.address = address

#    def __init__(self, code, name, city_id, address):
#        self.code = code
#        self.name = name
#        self.city_id = city_id
#        self.address = address
#
#    def __repr__(self):
#        return '<Hotel %r>' % (self.name)

    @staticmethod
    def from_json(json):
        h = Hotel(
            #code=json.get('code'),
            name=json.get('name'),
            city=json.get('city'),
            address=json.get('address')
        )

        return h

    def to_json(self):
        return {
            'id': self.id,
            #'code': self.code,
            'name': self.name,
            'city': self.city,
            'address': self.address
        }

